<template>
    <b-row>
        <b-col cols="12">
            <h2>
                Add user
                <b-link href="#/">(User List)</b-link>
            </h2>
            <b-jumbotron>
                <b-form @submit="onSubmit">
                    <b-form-group
                            id="fieldsetHorizontal"
                            horizontal
                            :label-cols="4"
                            breakpoint="md"
                            label="Enter team"
                    >
                        <b-form-input id="team" v-model.trim="user.team"></b-form-input>
                    </b-form-group>
                    <b-form-group
                            id="fieldsetHorizontal"
                            horizontal
                            :label-cols="4"
                            breakpoint="md"
                            label="Enter call_sign"
                    >
                        <b-form-input id="call_sign" v-model.trim="user.call_sign"></b-form-input>
                    </b-form-group>
                    <b-form-group
                            id="fieldsetHorizontal"
                            horizontal
                            :label-cols="4"
                            breakpoint="md"
                            label="Enter spec"
                    >
                        <b-form-input id="spec" v-model.trim="user.spec"></b-form-input>
                    </b-form-group>
                    <b-form-group
                            id="fieldsetHorizontal"
                            horizontal
                            :label-cols="4"
                            breakpoint="md"
                            label="Enter pay_grade"
                    >
                        <b-form-textarea
                                id="pay_grade"
                                v-model="user.pay_grade"
                                placeholder="Enter pay_grade"
                                :rows="2"
                                :max-rows="6"
                        >{{user.pay_grade}}</b-form-textarea>
                    </b-form-group>
                    <b-form-group
                            id="fieldsetHorizontal"
                            horizontal
                            :label-cols="4"
                            breakpoint="md"
                            label="Enter status"
                    >
                        <b-form-input id="status" v-model.trim="user.status"></b-form-input>
                    </b-form-group>
                    <b-form-group
                            id="fieldsetHorizontal"
                            horizontal
                            :label-cols="4"
                            breakpoint="md"
                            label="Enter expire"
                    >
                        <b-form-input type="text" id="issue" v-model.trim="user.expire"></b-form-input>
                    </b-form-group>
                    <b-form-group
                            id="fieldsetHorizontal"
                            horizontal
                            :label-cols="4"
                            breakpoint="md"
                            label="Enter issue"
                    >
                        <b-form-input type="text" id="issue" v-model.trim="user.issue"></b-form-input>
                    </b-form-group>
                    <b-form-group
                            id="fieldsetHorizontal"
                            horizontal
                            :label-cols="4"
                            breakpoint="md"
                            label="Enter rank_id"
                    >
                        <b-form-input type="text" id="rank_id" v-model.trim="user.rank_id"></b-form-input>
                    </b-form-group>
                    <b-form-group
                            id="fieldsetHorizontal"
                            horizontal
                            :label-cols="4"
                            breakpoint="md"
                            label="Enter card_id"
                    >
                        <b-form-input type="text" id="card_id" v-model.trim="user.card_id"></b-form-input>
                    </b-form-group>
                    <b-form-group
                            id="fieldsetHorizontal"
                            horizontal
                            :label-cols="4"
                            breakpoint="md"
                            label="Enter card_code"
                    >
                        <b-form-input type="text" id="card_code" v-model.trim="user.card_code"></b-form-input>
                    </b-form-group>
                    <b-button type="submit" variant="primary">Save</b-button>
                </b-form>
            </b-jumbotron>
        </b-col>
    </b-row>
</template>


<script>
  import gql from "graphql-tag";
  import router from "../router";

  const ADD_USER = gql`
  mutation addUser(
    $team: String!
    $call_sign: String!
    $spec: String!
    $pay_grade: String!
    $status: String!
    $issue: String!
    $expire: String!
    $rank_id: String!
    $card_id: String!
    $card_code: String!
  ) {
    addUser(
      team: $team,
      call_sign: $call_sign,
      spec: $spec,
      pay_grade: $pay_grade,
      status: $status,
      issue: $issue,
      expire: $expire,
      rank_id: $rank_id,
      card_id: $card_id,
      card_code: $card_code
    ) {
      id
    }
  }
`;

  export default {
    name: "AddUser",
    data() {
      return {
        user: {}
      };
    },
    methods: {
      onSubmit(evt) {
        evt.preventDefault();
        this.$apollo
          .mutate({
            mutation: ADD_USER,
            variables: {
              team: this.user.team,
              call_sign: this.user.call_sign,
              spec: this.user.spec,
              pay_grade: this.user.pay_grade,
              status: this.user.status,
              issue: this.user.issue,
              expire: this.user.expire,
              rank_id: this.user.rank_id,
              card_id: this.user.card_id,
              card_code: this.user.card_code
            }
          })
          .then(data => {
            console.log(data);
            router.push({ name: "UserList" });
          })
          .catch(error => {
            console.error(error);
          });
      }
    }
  };
</script>

<style>
    .jumbotron {
        padding: 2rem;
    }
</style>

